---
collections: 
    - name: primary_navigation
      next: community/index
description: docs
layout: dm:tutorial-list
title: Use Cases
---

# Use Cases

Resonance is perfect for applications development, blending rapid prototyping 
with streamlined code management. It enables quick validation of product 
hypotheses, allowing you to understand what features build positive user 
traction quickly. As applications evolve, the framework ensures consistent, 
readable, and standardized development.

Resonance is centered around the idea of using PHP to serve as a communication 
hub, interconnecting all your services through REST API, GraphQL, WebSockets, 
gRPC, and more. It allows you to quickly start and expand applications in an 
asynchronous environment and be able to set up all the necessary services and 
APIs, and then swap, replace, or expand all the application's components.

## Specific Use Cases

- Rapid feature prototyping
- Creating and expanding SaaS applications
- High-performance PHP applications
- Cross-service communication
- Streamlined codebase refactoring
- Memory usage optimization
- Asynchronous task management
- Applications’ integration with open source, self-hosted LLMs
